SimplePortletPostProcessor (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.web.portlet.handler

## Class SimplePortletPostProcessor

- java.lang.Object
- - org.springframework.web.portlet.handler.SimplePortletPostProcessor

- All Implemented Interfaces:
    Aware, BeanPostProcessor, DestructionAwareBeanPostProcessor, PortletConfigAware, PortletContextAware

      public class SimplePortletPostProcessor
      extends Object
      implements DestructionAwareBeanPostProcessor, PortletContextAware, PortletConfigAware

  Bean post-processor that applies initialization and destruction callbacks to beans that implement the Portlet interface.

  After initialization of the bean instance, the Portlet `init` method will be called with a PortletConfig that contains the bean name of the Portlet and the PortletContext that it is running in.

  Before destruction of the bean instance, the Portlet `destroy` will be called.

  Note that this post-processor does not support Portlet initialization parameters. Bean instances that implement the Portlet interface are supposed to be configured like any other Spring bean, that is, through constructor arguments or bean properties.

  For reuse of a Portlet implementation in a plain Portlet container and as a bean in a Spring context, consider deriving from Spring's GenericPortletBean base class that applies Portlet initialization parameters as bean properties, supporting both initialization styles.

  Alternatively, consider wrapping a Portlet with Spring's PortletWrappingController. This is particularly appropriate for existing Portlet classes, allowing to specify Portlet initialization parameters etc.

  Since:
    2.0
  Author:
    Juergen Hoeller, John A. Lewis
  See Also:
    `Portlet`, `PortletConfig`, `SimplePortletHandlerAdapter`, `GenericPortletBean`, `PortletWrappingController`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimplePortletPostProcessor()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Object` | `postProcessAfterInitialization(Object bean, String beanName)` Apply this BeanPostProcessor to the given new bean instance after any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method).
    `void` | `postProcessBeforeDestruction(Object bean, String beanName)` Apply this BeanPostProcessor to the given bean instance before its destruction.
    `Object` | `postProcessBeforeInitialization(Object bean, String beanName)` Apply this BeanPostProcessor to the given new bean instance before any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method).
    `void` | `setPortletConfig(PortletConfig portletConfig)` Set the PortletConfigthat this object runs in.
    `void` | `setPortletContext(PortletContext portletContext)` Set the PortletContext that this object runs in.
    `void` | `setUseSharedPortletConfig(boolean useSharedPortletConfig)` Set whether to use the shared PortletConfig object passed in through `setPortletConfig`, if available.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SimplePortletPostProcessor

          public SimplePortletPostProcessor()

  - ### Method Detail

    - #### setUseSharedPortletConfig

          public void setUseSharedPortletConfig(boolean useSharedPortletConfig)

      Set whether to use the shared PortletConfig object passed in through `setPortletConfig`, if available.

      Default is "true". Turn this setting to "false" to pass in a mock PortletConfig object with the bean name as portlet name, holding the current PortletContext.

      See Also:
        `setPortletConfig(javax.portlet.PortletConfig)`

    - #### setPortletContext

          public void setPortletContext(PortletContext portletContext)

      Description copied from interface: `PortletContextAware`
      Set the PortletContext that this object runs in.

      Invoked after population of normal bean properties but before an init callback like InitializingBean's afterPropertiesSet or a custom init-method. Invoked after ApplicationContextAware's setApplicationContext.

      Specified by:
        `setPortletContext` in interface `PortletContextAware`
      Parameters:
        `portletContext` - PortletContext object to be used by this object

    - #### setPortletConfig

          public void setPortletConfig(PortletConfig portletConfig)

      Description copied from interface: `PortletConfigAware`
      Set the PortletConfigthat this object runs in.

      Invoked after population of normal bean properties but before an init callback like InitializingBean's afterPropertiesSet or a custom init-method. Invoked after ApplicationContextAware's setApplicationContext.

      Specified by:
        `setPortletConfig` in interface `PortletConfigAware`
      Parameters:
        `portletConfig` - PortletConfig object to be used by this object

    - #### postProcessBeforeInitialization

          public Object postProcessBeforeInitialization(Object bean,
                                               String beanName)
                                                 throws BeansException

      Description copied from interface: `BeanPostProcessor`
      Apply this BeanPostProcessor to the given new bean instance before any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method). The bean will already be populated with property values. The returned bean instance may be a wrapper around the original.
      Specified by:
        `postProcessBeforeInitialization` in interface `BeanPostProcessor`
      Parameters:
        `bean` - the new bean instance
        `beanName` - the name of the bean
      Returns:
        the bean instance to use, either the original or a wrapped one; if `null`, no subsequent BeanPostProcessors will be invoked
      Throws:
        `BeansException` - in case of errors
      See Also:
        `InitializingBean.afterPropertiesSet()`

    - #### postProcessAfterInitialization

          public Object postProcessAfterInitialization(Object bean,
                                              String beanName)
                                                throws BeansException

      Description copied from interface: `BeanPostProcessor`
      Apply this BeanPostProcessor to the given new bean instance after any bean initialization callbacks (like InitializingBean's `afterPropertiesSet` or a custom init-method). The bean will already be populated with property values. The returned bean instance may be a wrapper around the original.

      In case of a FactoryBean, this callback will be invoked for both the FactoryBean instance and the objects created by the FactoryBean (as of Spring 2.0). The post-processor can decide whether to apply to either the FactoryBean or created objects or both through corresponding `bean instanceof FactoryBean` checks.

      This callback will also be invoked after a short-circuiting triggered by a `InstantiationAwareBeanPostProcessor.postProcessBeforeInstantiation(java.lang.Class<?>, java.lang.String)` method, in contrast to all other BeanPostProcessor callbacks.

      Specified by:
        `postProcessAfterInitialization` in interface `BeanPostProcessor`
      Parameters:
        `bean` - the new bean instance
        `beanName` - the name of the bean
      Returns:
        the bean instance to use, either the original or a wrapped one; if `null`, no subsequent BeanPostProcessors will be invoked
      Throws:
        `BeansException` - in case of errors
      See Also:
        `InitializingBean.afterPropertiesSet()`, `FactoryBean`

    - #### postProcessBeforeDestruction

          public void postProcessBeforeDestruction(Object bean,
                                          String beanName)
                                            throws BeansException

      Description copied from interface: `DestructionAwareBeanPostProcessor`
      Apply this BeanPostProcessor to the given bean instance before its destruction. Can invoke custom destruction callbacks.

      Like DisposableBean's `destroy` and a custom destroy method, this callback just applies to singleton beans in the factory (including inner beans).

      Specified by:
        `postProcessBeforeDestruction` in interface `DestructionAwareBeanPostProcessor`
      Parameters:
        `bean` - the bean instance to be destroyed
        `beanName` - the name of the bean
      Throws:
        `BeansException` - in case of errors
      See Also:
        `DisposableBean`, `AbstractBeanDefinition.setDestroyMethodName(java.lang.String)`